// finalVideoView.cpp : implementation of the CFinalVideoView class
//

#include "stdafx.h"
#include "finalVideo.h"

#include "finalVideoDoc.h"
#include "finalVideoView.h"

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
VTK INCLUDES
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
#include "vtkImageReader.h"
#include "vtkPolyDataReader.h" 
#include "vtkImageFlip.h"

#include "vtkContourFilter.h"
#include "vtkOutlineFilter.h"
#include "vtkWindowToImageFilter.h"
#include "vtkImageDataGeometryFilter.h"
#include "vtkTubeFilter.h"

#include "vtkMPEG2Writer.h"
#include "vtkCamera.h"
#include "vtkLookupTable.h"
#include "vtkArrowSource.h"
#include "vtkPropAssembly.h"

#include "vtkPolyDataMapper.h"
#include "vtkTextMapper.h"
#include "vtkActor.h"
#include "vtkScalarBarActor.h"
#include "vtkTextActor.h"
#include "vtkCaptionActor2D.h"

#include "vtkRenderer.h"
#include "vtkRenderWindow.h"
#include "vtkRenderWindowInteractor.h"

#include "vtkProperty.h"
#include "vtkProperty2D.h"
#include "vtkTextProperty.h"
#include "vtkCallbackCommand.h"
#include "vtkCommand.h"

#include "convert.h"
#include <string>
using std::string;
#define PI 3.14159265


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
VTK VARIABLES
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
vtkImageReader *basinReader;
vtkPolyDataReader *californiaReader ;
vtkImageReader *timestepReader;
vtkImageFlip *basinFlip;
vtkImageFlip *timestepFlip;

vtkContourFilter *basins;
vtkOutlineFilter *outline;
vtkWindowToImageFilter *w2if;
vtkImageDataGeometryFilter *sliceX;
vtkImageDataGeometryFilter *sliceZ;
vtkTubeFilter *axisTube;
vtkOutlineFilter *sliceXOutline;

vtkCamera *camera;
vtkCamera *axesCam;
vtkMPEG2Writer *mpegWriter;
vtkLookupTable *scalarBar;
vtkLookupTable *timeBar;
vtkArrowSource *xAxis;
vtkArrowSource *yAxis;
vtkArrowSource *zAxis;
vtkPropAssembly *Axes3D;
vtkCallbackCommand *command;

vtkPolyDataMapper *basinMapper;
vtkPolyDataMapper *outlineMapper;
vtkTextMapper *titleMapper;
vtkPolyDataMapper *sliceXMapper;
vtkPolyDataMapper *sliceZMapper;
vtkPolyDataMapper *xAxisMapper;
vtkPolyDataMapper *yAxisMapper;
vtkPolyDataMapper *zAxisMapper;
vtkPolyDataMapper *californiaMapper;
vtkPolyDataMapper *sliceXOutlineMapper;

vtkActor *basinActor;
vtkActor *outlineActor;
vtkScalarBarActor *scalarBarActor;
vtkScalarBarActor *timeBarActor;
vtkTextActor *titleActor;
vtkActor *sliceXActor;
vtkActor *sliceZActor;
vtkActor *xAxisActor;
vtkActor *yAxisActor;
vtkActor *zAxisActor;
vtkCaptionActor2D *xLabel;
vtkCaptionActor2D *yLabel;
vtkCaptionActor2D *zLabel;
vtkActor *californiaActor;
vtkActor *sliceXOutlineActor;

vtkRenderer *ren;
vtkRenderer *axesRen;
vtkRenderWindow *renwin;
vtkRenderWindowInteractor *iren;

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
OTHER VARIABLES
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
static int maxX = 749;
static int maxY = 374;
static int maxZ = 99;
static int spacing = 800;

/////////////////////////////////////////////////////////////////////////////
// CFinalVideoView

IMPLEMENT_DYNCREATE(CFinalVideoView, CFormView)

BEGIN_MESSAGE_MAP(CFinalVideoView, CFormView)
	//{{AFX_MSG_MAP(CFinalVideoView)
	ON_BN_CLICKED(IDC_BUTTONVIDEO1, OnButtonvideo1)
	ON_BN_CLICKED(IDC_BUTTONSTART, OnButtonstart)
	ON_BN_CLICKED(IDC_BUTTONVIDEO2, OnButtonvideo2)
	ON_BN_CLICKED(IDC_BUTTONVIDEO3, OnButtonvideo3)
	ON_BN_CLICKED(IDC_BUTTONVIDEO4, OnButtonvideo4)
	ON_BN_CLICKED(IDC_BUTTONVIDEO5, OnButtonvideo5)
	ON_BN_CLICKED(IDC_BUTTONMOD1, OnButtonmod1)
	ON_BN_CLICKED(IDC_BUTTONSPEED2, OnButtonspeed2)
	ON_BN_CLICKED(IDC_BUTTONPREV, OnButtonprev)
	ON_BN_CLICKED(IDC_BUTTONALL, OnButtonall)
	ON_BN_CLICKED(IDC_BUTTONPrueba, OnBUTTONPrueba)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFinalVideoView construction/destruction

CFinalVideoView::CFinalVideoView()
	: CFormView(CFinalVideoView::IDD)
{
	//{{AFX_DATA_INIT(CFinalVideoView)
	//}}AFX_DATA_INIT
	// TODO: add construction code here
}

CFinalVideoView::~CFinalVideoView()
{
}

void CFinalVideoView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFinalVideoView)
	//}}AFX_DATA_MAP
}

BOOL CFinalVideoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CFinalVideoView::OnInitialUpdate()
{	  
	CFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
}

/////////////////////////////////////////////////////////////////////////////
// CFinalVideoView diagnostics

#ifdef _DEBUG
void CFinalVideoView::AssertValid() const
{
	CFormView::AssertValid();
}

void CFinalVideoView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CFinalVideoDoc* CFinalVideoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFinalVideoDoc)));
	return (CFinalVideoDoc*)m_pDocument;
}
#endif //_DEBUG

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
OWN METHODS
++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

static void SyncCameras(vtkObject* obj, unsigned long, void *sr, void*){

	vtkCamera *cam = ren->GetActiveCamera();
    axesCam->SetViewUp(cam->GetViewUp());
    double *proj = new double[3];
	proj = cam->GetDirectionOfProjection();
    

    // figure out the distance away from 0 0 0
    // if the renderer resets the camera to optimally inlcude all props # composing the orientation marker
    double *bnds = new double[6];
	bnds = axesRen->ComputeVisiblePropBounds();
    axesRen->ResetCamera(bnds); //$x0 $x1 $y0 $y1 $z0 $z1
    double *pos = new double[3];
	pos = axesCam->GetPosition();
    double d = sqrt(pos[0]*pos[0]+ pos[1]*pos[1] + pos[2]*pos[2]);
    double dproj = sqrt(proj[0]*proj[0]+ proj[1]*proj[1] + proj[2]*proj[2]);

    // reset the camera back along the unit vector of the
    // direction of projection using our optimal distance
    axesCam->SetFocalPoint(0,0,0);
    axesCam->SetPosition(-d*proj[0]/dproj, -d*proj[1]/dproj, -d*proj[2]/dproj);
    axesRen->ResetCameraClippingRange();

}

/////////////////////////////////////////////////////////////////////////////
// CFinalVideoView message handlers

void CFinalVideoView::OnButtonstart() 
{
	// TODO: Add your control notification handler code here
	
	// Initialize basins stuff
	basinReader = vtkImageReader::New();
	  basinReader->SetFileName("C:/ramos y mas/PROY/data/TS21VelocityMesh_VS_R2.bin");
	  basinReader->SetFileDimensionality(3);
	  basinReader->SetDataScalarTypeToFloat();
	  basinReader->SetDataByteOrderToBigEndian();
	  basinReader->SetNumberOfScalarComponents(1);
	  basinReader->SetDataExtent(0,maxX,0,maxY,0,maxZ);
	  basinReader->SetDataSpacing(spacing,spacing,spacing);
	  //basinReader->SetDataOrigin(0,0,0);
	  basinReader->SetDataOrigin(-300000,-150000,-40000);
	
	basinFlip = vtkImageFlip::New();
	  basinFlip->SetInput((vtkDataObject*)basinReader->GetOutput());
	  basinFlip->SetFilteredAxis(1);
	  basinReader->Delete();

	basins = vtkContourFilter::New();
	  basins->SetInputConnection(basinFlip->GetOutputPort());
	  basins->SetValue(0,2500);
	  basinFlip->Delete();

	basinMapper = vtkPolyDataMapper::New();
	  basinMapper->SetInputConnection(basins->GetOutputPort());
	  basinMapper->ScalarVisibilityOff();

	basinActor = vtkActor::New();
	  basinActor->SetMapper(basinMapper);

	//initialize california map stuff
	californiaReader = vtkPolyDataReader::New();
	  californiaReader->SetFileName("C:/ramos y mas/PROY/data/ca_border_flipped.vtk");

	californiaMapper = vtkPolyDataMapper::New();
	  californiaMapper->SetInputConnection(californiaReader->GetOutputPort());

	californiaActor = vtkActor::New();
	  californiaActor->SetMapper(californiaMapper);
	  californiaActor->RotateX(180);
	  californiaActor->RotateZ(-90);
	  californiaActor->SetScale(0.8461,0.817,1);
	  californiaActor->AddPosition(-209000,92000,0);
	  californiaActor->GetProperty()->SetColor(1,0,0);

	//initialize scalar bar stuff
	scalarBar = vtkLookupTable::New();
	  scalarBar->SetTableRange(0.0000001, 3.1192195);
	  scalarBar->SetScaleToLog10();
	  scalarBar->SetHueRange(0.667, 0.0);
	  scalarBar->Build();
	  
	scalarBarActor = vtkScalarBarActor::New();
	  scalarBarActor->SetLookupTable(scalarBar);
	  scalarBarActor->SetTitle("Speed Magnitude (log scale)");
	  scalarBarActor->SetOrientationToHorizontal();
	  scalarBarActor->GetPositionCoordinate()->SetCoordinateSystemToNormalizedViewport();
	  scalarBarActor->GetPositionCoordinate()->SetValue(0.05,0.11);
	  scalarBarActor->SetWidth(0.9);
	  scalarBarActor->SetHeight(0.07);
	  
	//initalize time step stuff
	timestepReader = vtkImageReader::New();
	  //timestepReader->SetFileName("C:/ramos y mas/PROY/data/TS21z_VEL_R2_008000.bin");
	  timestepReader->SetFileDimensionality(3);
	  timestepReader->SetDataScalarTypeToFloat();
	  timestepReader->SetDataByteOrderToBigEndian();
	  timestepReader->SetNumberOfScalarComponents(1);
 	  timestepReader->SetDataExtent(0,maxX,0,maxY,0,maxZ);
	  timestepReader->SetDataSpacing(spacing,spacing,spacing);
	  timestepReader->SetDataOrigin(-300000,-150000,-40000);
	 
	timestepFlip = vtkImageFlip::New();
	  timestepFlip->SetInput((vtkDataObject*)timestepReader->GetOutput());
	  timestepFlip->SetFilteredAxis(1);	
	
	//initialize Z slice stuff
	sliceZ = vtkImageDataGeometryFilter::New();
	  sliceZ->SetInput((vtkDataObject*)timestepFlip->GetOutput());
	  sliceZ->SetExtent(0,maxX,0,maxY,maxZ,maxZ);
	  //timestepFlip->Delete();

	sliceZMapper = vtkPolyDataMapper::New();
	  sliceZMapper->SetInput(sliceZ->GetOutput());
	  sliceZMapper->SetLookupTable(scalarBar);
	  sliceZMapper->SetScalarRange(0.0000001, 3.1192195);
	  sliceZMapper->ScalarVisibilityOn();
		
	sliceZActor = vtkActor::New();
	  sliceZActor->SetMapper(sliceZMapper);

	//initialize X slice stuff
	sliceX = vtkImageDataGeometryFilter::New();
	  sliceX->SetInput((vtkDataObject*)timestepFlip->GetOutput());
	  sliceX->SetExtent(0,0,0,maxY,0,maxZ);
	  timestepFlip->Delete();

	sliceXMapper = vtkPolyDataMapper::New();
	  sliceXMapper->SetInput(sliceX->GetOutput());
	  sliceXMapper->SetLookupTable(scalarBar);
	  sliceXMapper->SetScalarRange(0.0000001, 3.1192195);
	  sliceXMapper->ScalarVisibilityOn();
		
	sliceXActor = vtkActor::New();
	  sliceXActor->SetMapper(sliceXMapper);

	// initialize outline stuff
	outline = vtkOutlineFilter::New();
	  outline->SetInput(basinFlip->GetOutput());

	outlineMapper = vtkPolyDataMapper::New();
	  outlineMapper->SetInput(outline->GetOutput());

	outlineActor = vtkActor::New();
	  outlineActor->SetMapper(outlineMapper);
	  outlineActor->GetProperty()->SetColor(1,1,1);

	//initialize X slice outline stuff
	sliceXOutline = vtkOutlineFilter::New();
	  sliceXOutline->SetInput(sliceX->GetOutput());

	sliceXOutlineMapper = vtkPolyDataMapper::New();
	  sliceXOutlineMapper->SetInput(sliceXOutline->GetOutput());

	sliceXOutlineActor = vtkActor::New();
	  sliceXOutlineActor->SetMapper(sliceXOutlineMapper);

	//initialize title stuff 
	titleMapper = vtkTextMapper::New();
	  titleMapper->SetInput("Sedimentary Basins");

	titleActor = vtkTextActor::New();
	  titleActor->SetMapper(titleMapper);
	  titleActor->GetTextProperty()->SetFontSize(24);
	  titleActor->GetPositionCoordinate()->SetCoordinateSystemToNormalizedViewport();
	  titleActor->GetPositionCoordinate()->SetValue(0.4,0.93);

	//initialize time bar stuff
	timeBar = vtkLookupTable::New();
	  timeBar->SetNumberOfTableValues(220);
	  timeBar->SetRange(0,220);
	  for(int w=0; w<220; w++)
		  timeBar->SetTableValue(w,1,1,1,1);
	  
	timeBarActor = vtkScalarBarActor::New();
	  timeBarActor->SetLookupTable(timeBar);
	  timeBarActor->SetTitle("Time");
	  timeBarActor->SetOrientationToHorizontal();
	  timeBarActor->SetNumberOfLabels(11);
	  timeBarActor->GetPositionCoordinate()->SetCoordinateSystemToNormalizedViewport();
	  timeBarActor->GetPositionCoordinate()->SetValue(0.05,0.03);
	  timeBarActor->SetWidth(0.9);
	  timeBarActor->SetHeight(0.07);

	//initialize axis stuff
	xAxis = vtkArrowSource::New();

	xAxisMapper = vtkPolyDataMapper::New();
	  xAxisMapper->SetInput(xAxis->GetOutput());

	xAxisActor = vtkActor::New();
	  xAxisActor->SetMapper(xAxisMapper);
	  xAxisActor->GetProperty()->SetColor(1,0,0);

	xLabel = vtkCaptionActor2D::New();
	  xLabel->SetCaption("X");
	  xLabel->SetAttachmentPoint(0.8,0,0);
	  xLabel->LeaderOff();
	  xLabel->BorderOff();
	  xLabel->SetPosition(0,0);

	yAxis = vtkArrowSource::New();

	yAxisMapper = vtkPolyDataMapper::New();
	  yAxisMapper->SetInput(yAxis->GetOutput());

	yAxisActor = vtkActor::New();
	  yAxisActor->SetMapper(yAxisMapper);
	  yAxisActor->RotateZ(90);
	  yAxisActor->GetProperty()->SetColor(0,1,0);

	yLabel = vtkCaptionActor2D::New();
	  yLabel->SetCaption("Y");
	  yLabel->SetAttachmentPoint(0,0.7,0);
	  yLabel->LeaderOff();
	  yLabel->BorderOff();
	  yLabel->SetPosition(0,0);
	
	zAxis = vtkArrowSource::New();

	zAxisMapper = vtkPolyDataMapper::New();
	  zAxisMapper->SetInput(zAxis->GetOutput());

	zAxisActor = vtkActor::New();
	  zAxisActor->SetMapper(zAxisMapper);
	  zAxisActor->RotateY(-90);
	  zAxisActor->GetProperty()->SetColor(0,0,0.8);

	zLabel = vtkCaptionActor2D::New();
	  zLabel->SetCaption("Z");
	  zLabel->SetAttachmentPoint(0,0,1);
	  zLabel->LeaderOff();
	  zLabel->BorderOff();
	  zLabel->SetPosition(0,0);


	Axes3D = vtkPropAssembly::New();	
	  Axes3D->AddPart(xAxisActor);
	  Axes3D->AddPart(xLabel);
	  Axes3D->AddPart(yAxisActor);
	  Axes3D->AddPart(yLabel);
	  Axes3D->AddPart(zAxisActor);
	  Axes3D->AddPart(zLabel);

	axesCam = vtkCamera::New();
	  axesCam->ParallelProjectionOn();

	axesRen = vtkRenderer::New();
	  axesRen->InteractiveOff();
	  axesRen->SetActiveCamera(axesCam);
	  axesRen->SetViewport(0,0.80,0.15,0.95);
	  axesRen->SetLayer(1);
	  axesRen->AddActor(Axes3D);
	  axesRen->ResetCameraClippingRange();

	//initialize rendering stuff
	command = vtkCallbackCommand::New();
	  command->SetCallback(SyncCameras);

	camera = vtkCamera::New();
	  camera->SetPosition(300000,150000,300000);//600,000 300,000 80,000
	  camera->SetFocalPoint(300000,150000,40000);

	ren = vtkRenderer::New();
	  ren->AddActor(californiaActor);
	  ren->AddActor(titleActor);
	  ren->SetBackground(0,0,0);
	  ren->SetActiveCamera(camera);
	  ren->ResetCamera();
	  //ren->AddObserver(vtkCommand::StartEvent, command);
	
	renwin = vtkRenderWindow::New();
	  renwin->SetNumberOfLayers(2);
	  renwin->SetSize(768,624);
	  renwin->AddRenderer(ren);

	iren = vtkRenderWindowInteractor::New();
	  iren->SetRenderWindow(renwin);
	  iren->Initialize();
	  iren->Render();
	  iren->Start();	

	//initialize recording stuff
	w2if = vtkWindowToImageFilter::New();
	  w2if->SetInput(renwin);

	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
}

//---------------------------------------------------------------------------------
// RECORDING OF THE FIRST PART OF THE VIDEO
// BASIN ISOSURFACE
//---------------------------------------------------------------------------------
void CFinalVideoView::OnButtonvideo1() 
{
	// TODO: Add your control notification handler code here 
	// uncomment if recording only this part of the video
	/*
	ren->RemoveActor(californiaActor);
	ren->AddActor(basinActor);
	ren->AddActor(outlineActor);

	ren->ResetCamera();
	ren->ResetCameraClippingRange();
	*/
	//
	titleMapper->SetInput("Basins are close to the surface");
	titleActor->GetPositionCoordinate()->SetValue(0.3,0.93);

	renwin->AddRenderer(axesRen);

	w2if = vtkWindowToImageFilter::New();
	  w2if->SetInput(renwin);
	
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part2-1.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();

	for(int i=0; i<=360; i+=4){
		
		basinActor->RotateY(4);
		outlineActor->RotateY(4);

		xAxisActor->RotateY(4);
		xLabel->SetAttachmentPoint(0.8*cos((2*3.14*i)/360),0,0);
		zAxisActor->RotateY(4);
		zLabel->SetAttachmentPoint(0.8*sin((2*3.14*i)/360),0,0);
		
		ren->ResetCameraClippingRange();
		
		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}
	mpegWriter->End();

}

//---------------------------------------------------------------------------------
// RECORDING OF A SEQUENCE OF TIMESTEPS SHOWING A SLICE OF
// SPEED MAGNITUDES
//---------------------------------------------------------------------------------
void CFinalVideoView::OnButtonvideo3() 
{
	// TODO: Add your control notification handler code here
	// uncomment if recording only this part of the video
	/*
	ren->RemoveActor(californiaActor);
	ren->AddActor(outlineActor);
	ren->ResetCamera();
	ren->ResetCameraClippingRange();
	renwin->AddRenderer(axesRen);
	*/
	//
	
	titleMapper->SetInput("Speed magnitude at surface level");
	titleActor->GetPositionCoordinate()->SetValue(0.3,0.93);
	
	for(int prev=0; prev<10; prev++)
		timeBar->SetTableValue(prev,1,0,0,1);
	
	ren->RemoveActor(basinActor);
	ren->AddActor(timeBarActor);
	ren->AddActor(scalarBarActor);
	ren->AddActor(sliceZActor);
	
	w2if = vtkWindowToImageFilter::New();
	  w2if->SetInput(renwin);
	  
	// recording of timesteps 10 - 50
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part3-1.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	
	for(int st1=10; st1<=50; st1+=10){

		string timestep = "";
		timestep += "C:/ramos y mas/PROY/data/TS21z_VEL_R2_00";
		timestep += stringify(st1);
		timestep += "00.bin";

		timestepReader->SetFileName(timestep.c_str());
		for(int i=(st1-10); i<=st1; ++i)
			timeBar->SetTableValue(i,1,0,0,1);
	
		iren->Render();
		
		for(int count=0; count<15; ++count){
			w2if->Modified();
			mpegWriter->Write();
		}

	}

	mpegWriter->End();
	mpegWriter->Delete();

	// recording of timesteps 60 - 90
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part3-2.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	
	for(int st2=60; st2<=90; st2+=10){

		string timestep = "";
		timestep += "C:/ramos y mas/PROY/data/TS21z_VEL_R2_00";
		timestep += stringify(st2);
		timestep += "00.bin";

		timestepReader->SetFileName(timestep.c_str());
		for(int i=(st2-10); i<=st2; ++i)
			timeBar->SetTableValue(i,1,0,0,1);
	
		iren->Render();
		
		for(int count=0; count<15; ++count){
			w2if->Modified();
			mpegWriter->Write();
		}

	}

	mpegWriter->End();
	mpegWriter->Delete();

}

//---------------------------------------------------------------------------------
//BEFORE ZOOMING INTO A BASIN, I NEED TO ROTATE THE VOLUME
//TO THE ADEQUATE POSITION
//---------------------------------------------------------------------------------
void CFinalVideoView::OnButtonvideo4() 
{
	// TODO: Add your control notification handler code here
	// uncomment if recording only this part of the video
	/*
	timestepReader->SetFileName("C:/ramos y mas/PROY/data/TS21z_VEL_R2_003000.bin");
	
	ren->RemoveActor(californiaActor);
	ren->AddActor(timeBarActor);
	ren->AddActor(outlineActor);
	ren->AddActor(scalarBarActor);
	ren->AddActor(sliceZActor);

	ren->ResetCamera();
	ren->ResetCameraClippingRange();

	renwin->AddRenderer(axesRen);
	*/
	//
	
	titleMapper->SetInput("Basin - Speed relation");
	titleActor->GetPositionCoordinate()->SetValue(0.3,0.93);
	ren->AddActor(basinActor);

	timestepReader->SetFileName("C:/ramos y mas/PROY/data/TS21z_VEL_R2_003000.bin");
	for(int r=0; r<=30; ++r)
		timeBar->SetTableValue(r,1,0,0,1);
	for(int w=31; w<220; ++w)
		timeBar->SetTableValue(w,1,1,1,1);

	w2if = vtkWindowToImageFilter::New();
	  w2if->SetInput(renwin);
	
	// horizontal rotation
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part6-1.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();

	for(int i=0; i<180; i+=3){
		basinActor->RotateX(3);
		sliceZActor->RotateX(3);
		outlineActor->RotateX(3);

		yAxisActor->RotateY(-3);
		yLabel->SetAttachmentPoint(0,0.7*cos((2*3.14*i)/360),0);
		zAxisActor->RotateZ(-3);
		zLabel->SetAttachmentPoint(0,-0.7*sin((2*3.14*i)/360),0);
		
		ren->ResetCameraClippingRange();
		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}

	for(double op=0.9; op>=0.4; op-=0.1){
		basinActor->GetProperty()->SetOpacity(op);
		
		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}

	mpegWriter->End();
	mpegWriter->Delete();

	// vertical rotation
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part6-2.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int j=0; j<45; j+=3){
		basinActor->RotateY(3);
		sliceZActor->RotateY(3);
		outlineActor->RotateY(3);

		xAxisActor->RotateY(-3);
		xLabel->SetAttachmentPoint(0.8*cos((2*3.14*j)/360),0,0);
		zAxisActor->RotateY(3);
		zLabel->SetAttachmentPoint(1.2*sin((2*3.14*j)/360),0,0);
		
		ren->ResetCameraClippingRange();
		renwin->Render();
		
		w2if->Modified();
		mpegWriter->Write();
		// second time to make it last longer in the video
		w2if->Modified();
		mpegWriter->Write();
	}

	mpegWriter->End();
	mpegWriter->Delete();

}

//---------------------------------------------------------------------------------
// RECORDES THE ZOOM INTO THE BASIN AREA OF INTEREST
//---------------------------------------------------------------------------------
void CFinalVideoView::OnButtonvideo2() 
{
	// TODO: Add your control notification handler code here
	
	// set up as if after recording previous stages
	// uncomment to record all sequences of the video
	/*	
	timestepReader->SetFileName("C:/ramos y mas/PROY/data/TS21z_VEL_R2_003000.bin");
	for(int r=0; r<=30; ++r)
		timeBar->SetTableValue(r,1,0,0,1);
	for(int w=31; w<220; ++w)
		timeBar->SetTableValue(w,1,1,1,1);
	
	basinActor->RotateX(180);
	sliceZActor->RotateX(180);
	sliceXActor->RotateX(180);
	outlineActor->RotateX(180);
	sliceXOutlineActor->RotateX(180);

	yAxisActor->RotateY(-180);
	zAxisActor->RotateZ(-180);
	
	basinActor->RotateY(44);
	sliceZActor->RotateY(44);
	sliceXActor->RotateY(44);
	outlineActor->RotateY(44);
	sliceXOutlineActor->RotateY(44);

	xAxisActor->RotateY(-44);
	zAxisActor->RotateY(44);
	xLabel->SetAttachmentPoint(0.8*cos((2*3.14*44)/360),0,0);
	yLabel->SetAttachmentPoint(0,-0.7,0);
	zLabel->SetAttachmentPoint(1.2*sin((2*3.14*44)/360),0,0);

	titleMapper->SetInput("Basin - Speed relation");
	titleActor->GetPositionCoordinate()->SetValue(0.3,0.93);
	basinActor->GetProperty()->SetOpacity(0.4);

	ren->RemoveActor(californiaActor);
	ren->AddActor(basinActor);
	ren->AddActor(outlineActor);
	ren->AddActor(scalarBarActor);
	ren->AddActor(sliceZActor);
	ren->AddActor(timeBarActor);
	ren->ResetCamera();
	ren->ResetCameraClippingRange();

	renwin->AddRenderer(axesRen);
	*/
	//
	
	ren->AddActor(sliceXActor);
	ren->AddActor(sliceXOutlineActor);

	// x slice
	w2if = vtkWindowToImageFilter::New();
	  w2if->SetInput(renwin);
	
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part7-1.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();

	for(int xpos=0; xpos<=300; xpos+=4){

		sliceX->SetExtent(xpos,xpos,0,maxY,0,maxZ);
		
		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}

	mpegWriter->End();
	mpegWriter->Delete();

	ren->RemoveActor(titleActor);
	ren->RemoveActor(scalarBarActor);
	ren->RemoveActor(timeBarActor);
	ren->SetViewport(0,0.2,1,0.9);

	double reduction = 3/10.0;
	double scale = 1+reduction;
	
	basinActor->SetScale(scale,scale,scale);
	sliceZActor->SetScale(scale,scale,scale);
	sliceXActor->SetScale(scale,scale,scale);
	outlineActor->SetScale(scale,scale,scale);
	sliceXOutlineActor->SetScale(scale,scale,scale);

	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part7-2.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();

	for(double s = scale; s<=(3+reduction); s+=0.05){
		
		basinActor->SetScale(s,s,s);//1.01,1.01,1.01);
		sliceZActor->SetScale(s,s,s);//1.01,1.01,1.01);
		sliceXActor->SetScale(s,s,s);
		outlineActor->SetScale(s,s,s);//1.01,1.01,1.01);
		sliceXOutlineActor->SetScale(s,s,s);

		ren->ResetCameraClippingRange();
		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}


	mpegWriter->End();
	mpegWriter->Delete();

}

//---------------------------------------------------------------------------------
//RECORDING TROUGH TIME HAVING A BASIN AS A FOCUS POINS
// i.e. AFTER THE ZOOM-IN
//---------------------------------------------------------------------------------
void CFinalVideoView::OnButtonvideo5() 
{
	// TODO: Add your control notification handler code here

	// set up as if after recording previous stages
	// uncomment to record all sequences of the video
	
	timestepReader->SetFileName("C:/ramos y mas/PROY/data/TS21z_VEL_R2_003000.bin");
	for(int r=0; r<=130; ++r)//30
		timeBar->SetTableValue(r,1,0,0,1);
	for(int w=131; w<220; ++w)
		timeBar->SetTableValue(w,1,1,1,1);
	
	basinActor->RotateX(180);
	sliceZActor->RotateX(180);
	sliceXActor->RotateX(180);
	outlineActor->RotateX(180);
	sliceXOutlineActor->RotateX(180);
	
	basinActor->RotateY(44);
	sliceZActor->RotateY(44);
	sliceXActor->RotateY(44);
	outlineActor->RotateY(44);
	sliceXOutlineActor->RotateY(44);

	yAxisActor->RotateY(-180);
	zAxisActor->RotateZ(-180);
	xAxisActor->RotateY(-44);
	zAxisActor->RotateY(44);
	xLabel->SetAttachmentPoint(0.8*cos((2*3.14*44)/360),0,0);
	yLabel->SetAttachmentPoint(0,-0.7,0);
	zLabel->SetAttachmentPoint(1.2*sin((2*3.14*44)/360),0,0);

	titleMapper->SetInput("Basin - Speed relation");
	titleActor->GetPositionCoordinate()->SetValue(0.3,0.93);
	basinActor->GetProperty()->SetOpacity(0.4);

	ren->RemoveActor(californiaActor);
	ren->AddActor(basinActor);
	ren->AddActor(outlineActor);
	ren->AddActor(sliceXActor);	
	ren->AddActor(sliceZActor);
	ren->AddActor(sliceXOutlineActor);
	ren->AddActor(scalarBarActor);
	ren->AddActor(timeBarActor);
	ren->AddActor(titleActor);
	
	ren->ResetCamera();
	ren->ResetCameraClippingRange();
	renwin->AddRenderer(axesRen);
	renwin->Render();

	ren->RemoveActor(titleActor);
	ren->RemoveActor(scalarBarActor);
	ren->RemoveActor(timeBarActor);
	
	ren->ResetCamera();
	renwin->Render();

	ren->SetViewport(0,0.2,1,0.9);

	double reduction = 3/10.0;
	double scale = 3+reduction;

	basinActor->SetScale(scale,scale,scale);
	sliceZActor->SetScale(scale,scale,scale);
	sliceXActor->SetScale(scale,scale,scale);
	outlineActor->SetScale(scale,scale,scale);
	sliceXOutlineActor->SetScale(scale,scale,scale);

	sliceX->SetExtent(300,300,0,maxY,0,maxZ);

	ren->ResetCameraClippingRange();
	renwin->Render();
	
	//
	
	w2if = vtkWindowToImageFilter::New();
	  w2if->SetInput(renwin);
	
	// time step 30 - 80
	/* mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part8-1.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int st1=30; st1<=80; st1+=10){

		string timestep = "";
		timestep += "C:/ramos y mas/PROY/data/TS21z_VEL_R2_00";
		timestep += stringify(st1);
		timestep += "00.bin";

		timestepReader->SetFileName(timestep.c_str());
		for(int i=(st1-10); i<=st1; ++i)
			timeBar->SetTableValue(i,1,0,0,1);

		ren->SetViewport(0,0,1,1);
		ren->RemoveActor(basinActor);
		ren->RemoveActor(sliceXActor);
		ren->RemoveActor(sliceZActor);
		ren->RemoveActor(outlineActor);
		ren->RemoveActor(sliceXOutlineActor);
		ren->AddActor(timeBarActor);
		ren->AddActor(titleActor);
		ren->AddActor(scalarBarActor);
		renwin->Render();
	
		ren->SetViewport(0,0.2,1,0.9);
		ren->RemoveActor(timeBarActor);
		ren->RemoveActor(titleActor);
		ren->RemoveActor(scalarBarActor);
		ren->AddActor(basinActor);
		ren->AddActor(sliceXActor);
		ren->AddActor(sliceZActor);
		ren->AddActor(outlineActor);
		ren->AddActor(sliceXOutlineActor);
		renwin->Render();
		
		for(int count=0; count<15; ++count){
			w2if->Modified();
			mpegWriter->Write();
		}

	}

	mpegWriter->End();
	mpegWriter->Delete();

	
	// time step 90 - 120
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part8-2.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int st2=90; st2<=120; st2+=10){

		string timestep = "";
		if(st2 < 100)
			timestep += "C:/ramos y mas/PROY/data/TS21z_VEL_R2_00";
		else
			timestep += "C:/ramos y mas/PROY/data/TS21z_VEL_R2_0";
		timestep += stringify(st2);
		timestep += "00.bin";

		timestepReader->SetFileName(timestep.c_str());
		for(int i=(st2-10); i<=st2; ++i)
			timeBar->SetTableValue(i,1,0,0,1);

		ren->SetViewport(0,0,1,1);
		ren->RemoveActor(basinActor);
		ren->RemoveActor(sliceXActor);
		ren->RemoveActor(sliceZActor);
		ren->RemoveActor(outlineActor);
		ren->RemoveActor(sliceXOutlineActor);
		ren->AddActor(timeBarActor);
		ren->AddActor(titleActor);
		ren->AddActor(scalarBarActor);
		renwin->Render();
	
		ren->SetViewport(0,0.2,1,0.9);
		ren->RemoveActor(timeBarActor);
		ren->RemoveActor(titleActor);
		ren->RemoveActor(scalarBarActor);
		ren->AddActor(basinActor);
		ren->AddActor(sliceXActor);
		ren->AddActor(sliceZActor);
		ren->AddActor(outlineActor);
		ren->AddActor(sliceXOutlineActor);
		renwin->Render();
		
		for(int count=0; count<15; ++count){
			w2if->Modified();
			mpegWriter->Write();
		}

	}

	mpegWriter->End();
	mpegWriter->Delete();	
	*/
	// time step 130 - 190	
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part8-3.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int st3=130; st3<=180; st3+=10){

		string timestep = "";
		timestep += "C:/ramos y mas/PROY/data/TS21z_VEL_R2_0";
		timestep += stringify(st3);
		timestep += "00.bin";

		timestepReader->SetFileName(timestep.c_str());
		for(int i=(st3-10); i<=st3; ++i)
			if (i!=220)
				timeBar->SetTableValue(i,1,0,0,1);

		ren->SetViewport(0,0,1,1);
		ren->RemoveActor(basinActor);
		ren->RemoveActor(sliceXActor);
		ren->RemoveActor(sliceZActor);
		ren->RemoveActor(outlineActor);
		ren->RemoveActor(sliceXOutlineActor);
		ren->AddActor(timeBarActor);
		ren->AddActor(titleActor);
		ren->AddActor(scalarBarActor);
		renwin->Render();
	
		ren->SetViewport(0,0.2,1,0.9);
		ren->RemoveActor(timeBarActor);
		ren->RemoveActor(titleActor);
		ren->RemoveActor(scalarBarActor);
		ren->AddActor(basinActor);
		ren->AddActor(sliceXActor);
		ren->AddActor(sliceZActor);
		ren->AddActor(outlineActor);
		ren->AddActor(sliceXOutlineActor);
		renwin->Render();
		
		for(int count=0; count<15; ++count){
			w2if->Modified();
			mpegWriter->Write();
		}

	}

	mpegWriter->End();
	mpegWriter->Delete();

	// time step 200 - 220	
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part8-4.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int st4=190; st4<=220; st4+=10){

		string timestep = "";
		timestep += "C:/ramos y mas/PROY/data/TS21z_VEL_R2_0";
		timestep += stringify(st4);
		timestep += "00.bin";

		timestepReader->SetFileName(timestep.c_str());
		for(int i=(st4-10); i<=st4; ++i)
			if (i!=220)
				timeBar->SetTableValue(i,1,0,0,1);

		ren->SetViewport(0,0,1,1);
		ren->RemoveActor(basinActor);
		ren->RemoveActor(sliceXActor);
		ren->RemoveActor(sliceZActor);
		ren->RemoveActor(outlineActor);
		ren->RemoveActor(sliceXOutlineActor);
		ren->AddActor(timeBarActor);
		ren->AddActor(titleActor);
		ren->AddActor(scalarBarActor);
		renwin->Render();
	
		ren->SetViewport(0,0.2,1,0.9);
		ren->RemoveActor(timeBarActor);
		ren->RemoveActor(titleActor);
		ren->RemoveActor(scalarBarActor);
		ren->AddActor(basinActor);
		ren->AddActor(sliceXActor);
		ren->AddActor(sliceZActor);
		ren->AddActor(outlineActor);
		ren->AddActor(sliceXOutlineActor);
		renwin->Render();
		
		for(int count=0; count<15; ++count){
			w2if->Modified();
			mpegWriter->Write();
		}

	}

	mpegWriter->End();
	mpegWriter->Delete();
}
//---------------------------------------------------------------------------------
//FIRST MODIFICATION
//RECORD A SLICE GOING THROUGH THE VOLUME IN TERMS OF DEPTH FOR A SINGLE TIMESTEP
//---------------------------------------------------------------------------------
void CFinalVideoView::OnButtonmod1() 
{
	// TODO: Add your control notification handler code here
	
	// set up as if after recording previous stages
	// uncomment to record all sequences of the video
	/*	
	timestepReader->SetFileName("C:/ramos y mas/PROY/data/TS21z_VEL_R2_009000.bin");

	titleMapper->SetInput("Basin effect on Speed (looking through depth)");
	titleActor->GetPositionCoordinate()->SetValue(0.15,0.93);

	basinActor->GetProperty()->SetOpacity(0.4);

	for(int r=0; r<=90; r++)
		timeBar->SetTableValue(r,1,0,0,1);

	ren->RemoveActor(californiaActor);
	ren->AddActor(basinActor);
	ren->AddActor(outlineActor);
	ren->AddActor(scalarBarActor);
	ren->AddActor(timeBarActor);
	ren->AddActor(sliceZActor);
	ren->ResetCamera();
	ren->ResetCameraClippingRange();

	renwin->AddRenderer(axesRen);
	*/
	//
	vtkLookupTable *depthBar = vtkLookupTable::New();
	  depthBar->SetNumberOfTableValues(100);
	  depthBar->SetRange(0,80);
	  for(int w=0; w<100; w++)
		  depthBar->SetTableValue(w,1,1,1,1);
	  
	vtkScalarBarActor *depthBarActor = vtkScalarBarActor::New();
	  depthBarActor->SetLookupTable(depthBar);
	  depthBarActor->SetTitle("Depth (km.)");
	  depthBarActor->SetOrientationToVertical();
	  depthBarActor->SetNumberOfLabels(9);
	  //depthBarActor->SetLabelFormat("%-#2.0g");
	  depthBarActor->GetPositionCoordinate()->SetCoordinateSystemToNormalizedViewport();
	  depthBarActor->GetPositionCoordinate()->SetValue(0.85,0.20);
	  depthBarActor->SetWidth(0.1);
	  depthBarActor->SetHeight(0.7);
	  depthBarActor->GetProperty()->SetOpacity(0.5);
	
	ren->AddActor(depthBarActor);
	  
	w2if = vtkWindowToImageFilter::New();
	  w2if->SetInput(renwin);
	
	// depth 0 -> 40
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part4-1.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int i = maxZ; i >( maxZ/2); i--){
		
		sliceZ->SetExtent(0,maxX,0,maxY,i,i);
		depthBar->SetTableValue(maxZ-i,0,0,0,1);

		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}

	mpegWriter->End();
	mpegWriter->Delete();

	//depth 40->80
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part4-2.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int k = maxZ/2; k >= 0; k--){
		
		sliceZ->SetExtent(0,maxX,0,maxY,k,k);
		depthBar->SetTableValue(maxZ-k,0,0,0,1);

		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}

	mpegWriter->End();
	mpegWriter->Delete();
	
	//depth 80 -> 40
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part4-3.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int j = 0; j < (maxZ/2); j++){
		
		sliceZ->SetExtent(0,maxX,0,maxY,j,j);
		depthBar->SetTableValue(maxZ-j,1,1,1,1);

		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}
	mpegWriter->End();
	mpegWriter->Delete();

	// depth 40 -> 0
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part4-4.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int l = (maxZ/2); l <= maxZ; l++){
		
		sliceZ->SetExtent(0,maxX,0,maxY,l,l);
		depthBar->SetTableValue(maxZ-l,1,1,1,1);

		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}
	mpegWriter->End();
	mpegWriter->Delete();
	
	ren->RemoveActor(depthBarActor);
	depthBar->Delete();
	depthBarActor->Delete();

}
//---------------------------------------------------------------------------------
//SECOND MODIFICATION
//FROM THE SPEED, I HAVE NOW DIFFERENT BUTTONS TO START BOTH PARTS, IN THAT WAY, I CAN
//ADD THE DEPTH VIDEO INBETWEEN
//---------------------------------------------------------------------------------
void CFinalVideoView::OnButtonspeed2() 
{
	// TODO: Add your control notification handler code here
	
	// set up as if after recording previous stages
	// comment when recording all sequences of the video
	/*
	timestepReader->SetFileName("C:/ramos y mas/PROY/data/TS21z_VEL_R2_009000.bin");
	for(int r=0; r<=90; r++)
		timeBar->SetTableValue(r,1,0,0,1);

	ren->RemoveActor(californiaActor);
	ren->AddActor(outlineActor);
	ren->AddActor(scalarBarActor);
	ren->AddActor(timeBarActor);
	ren->AddActor(sliceZActor);

	ren->ResetCamera();
	ren->ResetCameraClippingRange();
	
	renwin->AddRenderer(axesRen);
	*/
	//

	ren->RemoveActor(basinActor);
	titleMapper->SetInput("Speed magnitude at surface level");
	titleActor->GetPositionCoordinate()->SetValue(0.3,0.93);
	
	w2if = vtkWindowToImageFilter::New();
	  w2if->SetInput(renwin);
	
	// time steps 100 - 150
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part5-1.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int st1=100; st1<=150; st1+=10){

		string timestep = "";
		timestep += "C:/ramos y mas/PROY/data/TS21z_VEL_R2_0";
		timestep += stringify(st1);
		timestep += "00.bin";

		timestepReader->SetFileName(timestep.c_str());
		for(int i=(st1-10); i<=st1; ++i){
			timeBar->SetTableValue(i,1,0,0,1);
		}
	
		iren->Render();
		
		for(int count=0; count<15; ++count){
			w2if->Modified();
			mpegWriter->Write();
		}

	}

	mpegWriter->End();
	mpegWriter->Delete();
	
	// time steps 160 - 200
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part5-2.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int st2=160; st2<=200; st2+=10){

		string timestep = "";
		timestep += "C:/ramos y mas/PROY/data/TS21z_VEL_R2_0";
		timestep += stringify(st2);
		timestep += "00.bin";

		timestepReader->SetFileName(timestep.c_str());
		for(int i=(st2-10); i<=st2; ++i){
			timeBar->SetTableValue(i,1,0,0,1);
		}
	
		iren->Render();
		
		for(int count=0; count<15; ++count){
			w2if->Modified();
			mpegWriter->Write();
		}

	}

	mpegWriter->End();
	mpegWriter->Delete();

	// time steps 210 - 220
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part5-3.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	
	for(int st3=210; st3<=220; st3+=10){

		string timestep = "";
		timestep += "C:/ramos y mas/PROY/data/TS21z_VEL_R2_0";
		timestep += stringify(st3);
		timestep += "00.bin";

		timestepReader->SetFileName(timestep.c_str());
		for(int i=(st3-10); i<=st3; ++i){
			if(i != 220)
				timeBar->SetTableValue(i,1,0,0,1);
		}
	
		iren->Render();
		
		for(int count=0; count<15; ++count){
			w2if->Modified();
			mpegWriter->Write();
		}

	}

	mpegWriter->End();
	mpegWriter->Delete();
	
}

//---------------------------------------------------------------------------------
//THIRD MODIFICATION
//ADDS AT THE BEGINNING A SEQUENCE THAT SHOWS WHERE THE BASINS ARE LOCATED IN
//RELATION TO CALIFORNIA 
//
// PARTS 0-1, 0-2, 0-3
//---------------------------------------------------------------------------------
void CFinalVideoView::OnButtonprev() 
{
	// TODO: Add your control notification handler code here
	titleMapper->SetInput("State of California");

	outlineActor->GetProperty()->SetOpacity(0);
	basinActor->GetProperty()->SetOpacity(0);
	
	ren->AddActor(outlineActor);
	ren->AddActor(basinActor);
	
	w2if = vtkWindowToImageFilter::New();
	  w2if->SetInput(renwin);
	
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part0-1.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();

	// recording a static image of the california map 30 frames (2 secs at 15fps)
	for(int si=0; si<30; si++){
		w2if->Modified();
		mpegWriter->Write();
	}
	mpegWriter->End();
	mpegWriter->Delete();

	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part0-2.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();
	  
	// recording the rotation of the map. 79 frames (aprox 5 secs at 15fps)
	for(double i=0; i>=-39.5; i-=0.5){
		californiaActor->RotateZ(-0.5);

		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}
	mpegWriter->End();
	mpegWriter->Delete();

	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part0-3.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();

	// recording the basins location on top of california
	// using 30 frames (2 secs at 15 fps)
	for(double j=30; j>0; j--){
		
		outlineActor->GetProperty()->SetOpacity((double)1.0/j);
		basinActor->GetProperty()->SetOpacity((double)1.0/j);

		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();
	}

	mpegWriter->End();
	mpegWriter->Delete();

}
//---------------------------------------------------------------------------------

//---------------------------------------------------------------------------------
void CFinalVideoView::OnButtonall() 
{
	// TODO: Add your control notification handler code here
	CFinalVideoView::OnButtonprev();
	CFinalVideoView::OnButtonvideo1();
	CFinalVideoView::OnButtonvideo3();
	CFinalVideoView::OnButtonmod1();
	CFinalVideoView::OnButtonspeed2();
	CFinalVideoView::OnButtonvideo4();
	CFinalVideoView::OnButtonvideo2();
	CFinalVideoView::OnButtonvideo5();
}
//---------------------------------------------------------------------------------

//---------------------------------------------------------------------------------
void CFinalVideoView::OnBUTTONPrueba() 
{
	// TODO: Add your control notification handler code here
	// uncomment if recording only this part of the video
	/*
	ren->AddActor(basinActor);
	ren->AddActor(outlineActor);
	
	basinActor->GetProperty()->SetOpacity(1);
	*/
	//

	titleMapper->SetInput("Basin Location");

	double fpx1, fpy1, fpz1;
	double px1,py1,pz1;

	ren->GetActiveCamera()->GetFocalPoint(fpx1,fpy1,fpz1);
	ren->GetActiveCamera()->GetPosition(px1,py1,pz1);

	ren->RemoveActor(californiaActor);
	ren->ResetCamera();
	ren->ResetCameraClippingRange();

	double fpx2, fpy2, fpz2;
	double px2, py2, pz2;

	ren->GetActiveCamera()->GetFocalPoint(fpx2, fpy2, fpz2);
	ren->GetActiveCamera()->GetPosition(px2, py2, pz2);
	renwin->Render();

	ren->AddActor(californiaActor);
	ren->ResetCamera();
	ren->ResetCameraClippingRange();

	ren->GetActiveCamera()->SetFocalPoint(fpx1, fpy1, fpz1);
	ren->GetActiveCamera()->SetPosition(px1, py1, pz1);
	renwin->Render();

	double dpx = px2-px1; //delta position point
	double dfpx = fpx2-fpx1; //delta focal point
	double spx = dpx/45; //step position
	double sfpx = dfpx/45; //step focal point

	double dpy = py2-py1;
	double dfpy = fpy2-fpy1;
	double spy = dpy/45;
	double sfpy = dfpy/45;

	double dpz = pz2-pz1;
	double dfpz = fpz2-fpz1;
	double spz = dpz/45;
	double sfpz = dfpz/45;

	w2if = vtkWindowToImageFilter::New();
	  w2if->SetInput(renwin);
	
	mpegWriter = vtkMPEG2Writer::New();
	  mpegWriter->SetFileName("part1-1.mpg");
	  mpegWriter->SetInputConnection(w2if->GetOutputPort());
	  mpegWriter->Start();

	
	ren->RemoveActor(californiaActor);  
	for(int i=1; i<=45; ++i){

		px1+= spx;
		py1+= spy;
		pz1+= spz;

		fpx1+= sfpx;
		fpy1+= sfpy;
		fpz1+= sfpz;
		
		ren->GetActiveCamera()->SetFocalPoint(fpx1,fpy1,fpz1);
		ren->GetActiveCamera()->SetPosition(px1,py1,pz1);
		ren->ResetCameraClippingRange();
		ren->Clear();
		renwin->Render();
		w2if->Modified();
		mpegWriter->Write();

	}

	mpegWriter->End();
	mpegWriter->Delete();

}
